<img src="doc/logo/lynx_logo.png" alt="drawing" width="250"/>

# Lynx On-Board Software [![pipeline status](https://git.skywarder.eu/scs/lynx/obsw/badges/master/pipeline.svg)](https://git.skywarder.eu/scs/lynx/obsw/commits/master)

*On Board software for Lynx*

To clone, use `git clone --recurse-submodules git@git.skywarder.eu:scs/lynx/obsw.git`.

To build, use `sbs` (for more info, type `./sbs --help` on Linux or `sbs --help` on Windows).

## Folder structure

|   Folder               |   Content                                                    |
| ---------------------- | ------------------------------------------------------------ |
| src/boards/            | Classes and components, divided by board.                    |
| src/entrypoints/       | Each file here is a "*main*" to be built with SBS.           |
| src/tests/             | Tests that can be built with SBS.                            |
| skyward-boardcore/     | Provides the build system (SBS) and common drivers.          |
| bin/                   | Compiled binaries generated by SBS, to be flashed on boards. |
| build/                 | MIOSIX Makefiles generated by SBS (*not important*)          |
| obj/                   | Building stuff (*not important*)                             |


## Useful entrypoints

### Death Stack X Test Suite `src/entrypoints/death-stack-x-testsuite.cpp`

Interactive entrypoint to test various aspects of the Death Stack hardware / software:  

| Test              | Description                                              |
| ----------------- | -------------------------------------------------------- |
| Test power board  | Allows to test battery voltage, cutters and servo motors |
| Test stm board    | Allows to test leds and external oscillator              | 
| Test rf board     | Allows to test the IMUs, GPS and SD Card                 |
| Test analog board | Allows to test the pressure sensors and detachment pins  |

### Death Stack X Entry `src/entrypoints/death-stack-x-entry.cpp`

Main entrypoint to be used for flight

## Contributing

If you are developing new features, branch off from the `testing` branch and then merge back.
